---
import BasicLayout from '@layouts/Basic.astro'
import { nhost } from '@utils/NhostClient.js'
import { slugFromFilename } from '@utils/formatting'
import '@styles/articleLayout.css'

// Let's get the concepts static paths and their data, to create their pages:
// - https://docs.astro.build/en/core-concepts/routing/#dynamic-routes
export async function getStaticPaths() {
  // First we get the texts from the Markdown files:
  // - https://docs.astro.build/en/guides/markdown-content/#importing-markdown
  // - https://docs.astro.build/en/reference/api-reference/#astroglob
  const conceptsMarkdowns = await Astro.glob('../../content/concepts/*.md')
  // Now we get the concepts list, their other info and associations from the database:
  const response = await nhost.graphql.request(`
    query {
      concepts {
        title
        slug
        people(order_by: {person: {name: asc}}) {
          person {
            name
            slug
          }
        }
      }
    }
  `)
  // For each concept we get its content from its Markdown file and their params (paths to build) and props (other info):
  const pathsAndProps = response.data.concepts.map(concept => {
    const conceptMarkdownContent = conceptsMarkdowns.find( 
      markdown => slugFromFilename(markdown.file) == concept.slug
    ).Content
    return { 
      params: { slug: concept.slug },
      props: { title: concept.title,
               relatedPeople: concept.people,
               Content: conceptMarkdownContent }
    }
  })
  return pathsAndProps
}

// Now we prepare the data for each page/concept:
// - Destructing the props into individual constants for easier use below:
const { title, 
        relatedPeople, 
        Content } = Astro.props
// - Preparing the related people list (if any):
var peopleNav
const peopleIndex = `<a class="goToIndex" href="/filosofos/">índice de filósofos(as)</a>`
if (relatedPeople.length > 0) {
  peopleNav = (
    `<ul>` +
      relatedPeople.map((relatedPerson) => (
        `<li><a href="/filosofo/${relatedPerson.person.slug}">${relatedPerson.person.name}</a></li>`
      )).join('\n') +
    `</ul>` + peopleIndex
  )
} else {
  peopleNav = `<p>Não há nenhum filósofo relacionado.</p>` + peopleIndex
}

// The content for page metadata & Open Graph metadata:
const canonicalURL = new URL(Astro.url.pathname, Astro.site);
const metaTitle = title;
const metaDescription = `Sobre o conceito ${title}.`;
const metaCanonicalURL = canonicalURL.href;
const metaType = "website";
const metaImage = canonicalURL.origin + "/images/Rembrandt_-_The_Philosopher_in_Meditation.jpg";
---
	
<BasicLayout metaTitle={metaTitle}
						 metaDescription={metaDescription}
						 metaCanonicalURL={metaCanonicalURL}
						 metaType={metaType}
						 metaImage={metaImage}>

  <article>

    <h1>{title}</h1>

    <Content />

  </article>

  <nav class="navSide" set:html={peopleNav}>
    <h2>Filósofos(as) relacionados(as)</h2>
  </nav>

  <a class="backToIndex" href="/conceitos">índice de conceitos</a>

</BasicLayout>
